#!/usr/bin/perl -w

use strict;

my $sendmail = '/usr/lib/sendmail -oi -t';
my $update = '/usr/bin/online_update -s -d';
my $urlfile = '/etc/update_url';
my $server_url = 'nfs://suse.eng.cam.ac.uk/suse/updates'; # default
my $hostname = `uname -n`;

if (open (URL, $urlfile)) {
	$server_url = <URL>;
	chomp $server_url;
} else {
	warn "Unable to read $urlfile: $!\n";
}

print "Using $server_url as source of updates\n";

open (UPDATE, "$update -s -d -u $server_url|")
	or die "Unable to run $update to $server_url: !$\n";

my @out;
while (<UPDATE>) {
	next unless /^INSTALL/;
	push (@out, $_);
}
close (UPDATE);

exit 0 unless scalar @out;

open (MAIL, "|$sendmail") or die "Unable to run $sendmail: $!\n";
print MAIL <<EOF;
To: root
Subject: do_online_update output for $hostname

@out
EOF
close (MAIL);

exit 0;
